/*         
 ..,  ..
    
tnsfloat@mail.ru
 0.1

     .
        
,  ,     .
*/
#ifndef TNSFLOAT_H
#define TNSFLOAT_H

#include<stdio.h>
#include<math.h>
//   
void (*mul)(signed char *exp, signed char *manti, int eSize, int mSize, signed char *leftExpo, signed char *leftMant,
    signed char *rightExpo, signed char *rightMant, signed char *eTmp, signed char *cMul);
void (*add)(signed char *exp, signed char *manti, int eSize, int mSize, signed char *leftExpo, signed char *leftMant,
    signed char *rightExpo, signed char *rightMant, signed char *eTmp);
void(*inversStr)(signed char *value, int size);
void (*div)(signed char *exp, signed char *manti, int eSize, int mSize, signed char *dividentEx, signed char *dividentMa,
    signed char *measureEx, signed char *measureMa, signed char *quotientLeft, signed char *quotientRight, signed char *curDeduction,
    signed char *eTmp);
//   
const int expoSIZE = 5, mantSIZE = 15;

struct TNSFLOAT
{
    signed char expo[expoSIZE+1], mant[mantSIZE+1];
/*TNSFLOAT-  2-    ,    .
     .
  TNSFLOAT-     0,
   - ,    .
       TNSFLOAT .
   13.200 *    0.700 =   9.24000	0.100171777 t000010
   12.200 *    1.700 =  20.74000	0.171071700 t000011
   11.200 *    2.700 =  30.24000	0.101017177 t000011
   10.200 *    3.700 =  37.74000	0.111771700 t000011
    9.200 *    4.700 =  43.24000	0.177711701 t000177
    8.200 *    5.700 =  46.74000	0.177177170 t000177
    7.200 *    6.700 =  48.24000	0.177101701 t000177
    6.200 *    7.700 =  47.74000	0.177107170 t000177
    5.200 *    8.700 =  45.24000	0.177001701 t000177
    4.200 *    9.700 =  40.74000	0.177777170 t000177
    3.200 *   10.700 =  34.24000	0.117117011 t000011
    2.200 *   11.700 =  25.74000	0.100771707 t000011
    1.200 *   12.700 =  15.24000	0.177017011 t000011
    0.200 *   13.700 =   2.74000	0.107170000 t000017
   -0.800 *   14.700 = -11.76000	0.770170110 t000010
   -1.800 *   15.700 = -28.26000	0.700771700 t000011
   -2.800 *   16.700 = -46.76000	0.711711701 t000177
   -3.800 *   17.700 = -67.26000	0.717777170 t000177
   -4.800 *   18.700 = -89.76000	0.707001710 t000177
*/
    TNSFLOAT()/*,    .*/;
    ~TNSFLOAT()/**/;
    TNSFLOAT &operator = (const double fl)/* double 
 TNSFLOAT .*/;
    TNSFLOAT &operator = (const TNSFLOAT &value)/*   
  .*/;
};

double tnsToFloat(TNSFLOAT value)/*  TNSFLOAT   double.*/;
void printTnsFloat(TNSFLOAT value)/*  TNSFLOAT .
  -1   7.*/;

TNSFLOAT operator /=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 /=.*/;
TNSFLOAT operator *=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 *=.*/;
TNSFLOAT operator -=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 -=.*/;
TNSFLOAT operator +=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 +=.*/;
bool operator >= (const TNSFLOAT &left, const TNSFLOAT &right)/* 
    2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
    c 1.*/;
bool operator <= (const TNSFLOAT &left, const TNSFLOAT &right)/* 
    2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
    c 1.*/;
bool operator <  (const TNSFLOAT &left, const TNSFLOAT &right)/* 
  2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
    c -1.*/;
bool operator >  (const TNSFLOAT &left, const TNSFLOAT &right)/* 
  2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
     1.*/;
bool operator != (const TNSFLOAT &left, const TNSFLOAT &right)/* 
 .
 2- TNSFLOAT ,      ,  .
   .*/;
bool operator == (const TNSFLOAT &left, const TNSFLOAT &right)/* 
 .
 2- TNSFLOAT ,      ,  .
   .*/;
TNSFLOAT operator / (const TNSFLOAT &left, const TNSFLOAT &right)/* 
.
 2- TNSFLOAT ,        
.
  ,  2-   ,  
 .   div. */;
TNSFLOAT operator + (const TNSFLOAT &left, const TNSFLOAT &right)/* 
2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   add. */;
TNSFLOAT operator - (const TNSFLOAT &left, const TNSFLOAT &right)/* 
2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add. */;
TNSFLOAT operator * (const TNSFLOAT &left, const TNSFLOAT &right)/* 
2- TNSFLOAT .
 2- TNSFLOAT ,        
.
    .   mul. */;
TNSFLOAT operator - (const TNSFLOAT &value)/* , ,   -1.
 TNSFLOAT ,        inversStr()*/;
TNSFLOAT abs(TNSFLOAT &value)/*   TNSFLOAT .
 TNSFLOAT ,    ,   ,
   inversStr() */;

#endif // TNSFLOAT_H
