.586
.XMM
.MODEL FLAT
	PUBLIC _addSSEasm@12 
	PUBLIC _subSSEasm@12 
	PUBLIC _mulSSEasm@12 
	PUBLIC _divSSEasm@12 
.CODE
_start@12:
	mov	al,	1		
	ret	12

_divSSEasm@12 PROC
	push	ebp
	mov		ebp,	esp

	mov		eax,	[ebp+08];
	mov		edx,	[ebp+12];
	mov		ecx,	[ebp+16];
	movups	xmm1,		[ecx]
	movups	xmm0,		[edx]
	divps	xmm1,		xmm0;
	movups	[eax],	xmm1

	pop		ebp
	ret
_divSSEasm@12 ENDP
	
_mulSSEasm@12 PROC
	push	ebp
	mov		ebp,	esp

	mov		eax,	[ebp+08];
	mov		edx,	[ebp+12];
	mov		ecx,	[ebp+16];
	movups	xmm1,		[ecx]
	movups	xmm0,		[edx]
	mulps	xmm1,		xmm0;
	movups	[eax],	xmm1

	pop		ebp
	ret
_mulSSEasm@12 ENDP
	
_subSSEasm@12 PROC
	push	ebp
	mov		ebp,	esp

	mov		eax,	[ebp+08];
	mov		edx,	[ebp+12];
	mov		ecx,	[ebp+16];
	movups	xmm1,		[ecx]
	movups	xmm0,		[edx]
	subps	xmm1,		xmm0;
	movups	[eax],	xmm1

	pop		ebp
	ret
_subSSEasm@12 ENDP

_addSSEasm@12 PROC
	push	ebp
	mov		ebp,	esp

	mov		eax,	[ebp+08];
	mov		edx,	[ebp+12];
	mov		ecx,	[ebp+16];
	movups	xmm1,		[ecx]
	movups	xmm0,		[edx]
	addps	xmm1,		xmm0;
	movups	[eax],	xmm1

	pop		ebp
	ret
_addSSEasm@12 ENDP

END	_start@12
